/* $Id$
   $Locker$	$Name$	$State$


   $Log$
*/

#ifndef __PORTABLE_H
#define __PORTABLE_H

#include <regproto.h>
#define NUL '\0'
#define MK_OSVERS(major,minor) ((major << 8) | (minor))

#ifdef _MICROC_
#include <external.h>	/* non-predeclared global variables */

#define iM(q)	q		/* if Micro-C */
#define nM(q)			/* not Mirco-C */
#define inM(q,w)	q	/* if-not Micro-C */
#define aF(fct) &(fct)		/* address of function */
#define aS(structure) (structure)	/* address of structure */
#define cS(strucType)		/* no structure casting */
/* The definition of TO_FP resides in <fmemory.h> */

#ifndef NULL
#define NULL 0
#endif

#define peekb peek
#define pokeb poke
#define const
#define _psp PSP

/* Global argc/argv variables */
#define G_ARGV ARGV		/* global char **argv	variable */
#define G_ARGC ARGC		/* global int argc	variable */
#define G_ARG_DEF		/* definition of global variables */
#define G_ARG_INIT		/* initialization of global variables */

/* Handling of pointers to structures */
#define sInc(poi) ((poi) += sizeof(*(poi)))
#define sDec(poi) ((poi) -= sizeof(*(poi)))
#define sIdx(array,index) ((array) + (index) * sizeof(*(array)))
#define sAdd(poi,displacement) ((poi) += (displacement) * sizeof(*(array)))
#define sSub(poi,displacement) ((poi) -= (displacement) * sizeof(*(array)))

/* byte/word/dword type */
#define byte unsigned char
#define word unsigned
#define FLAG byte	/* Micro-C has special 8-bit handling */
#define FLAG8 byte	/* dito */
#define get_ss get_ds

#define dword struct DWORD
struct DWORD {
	word lo;	/* offset */
	word hi;	/* segment */
};
#define setDW(var,seg,ofs) (var.hi = (seg), var.lo = (ofs))
/* Micro-C does not support (*struct_pointer).member for struct_pointer->member */
#define setDWP(varP,seg,ofs) (varP->hi = (seg), varP->lo = (ofs))
#define DW_LO(var) var.lo
#define DW_HI(var) var.hi
#define DWP_LO(varP) varP->lo
#define DWP_HI(varP) varP->hi
#define DWARG dword *			/* dword argument */

/* Simulate long constants and long arguments */
#define TO_LONG(num) 0, (unsigned)(num)
#define MK_LONG(hi,lo) (unsigned)(hi), (unsigned)(lo)
#define FARARG(var,type) word var/**/Seg, word var/**/Ofs
#define COPYFARARG(var) var/**/Seg, var/**/Ofs

/* version variables */
#define _osmajor ((unsigned)version() >> 8)
#define _osminor (version() & 0xff)
#define _osversion version()


#else	/* no _MICROC_ */

/* mainly Borland */
#define iM(q)			/* if Micro-C */
#define nM(q)	q		/* not Mirco-C */
#define inM(q,w)	w	/* if-not Micro-C */
#define aF(fct) (fct)		/* address of function */
#define aS(structure) &(structure)	/* address of structure */
#define cS(strucType) (strucType)	/* casting of a structure */


/* Global argc/argv variables */
#define G_ARGV _argv		/* global char **argv	variable */
#define G_ARGC _argc		/* global int argc	variable */
#define G_ARG_DEF			/* definition of global variables */
#define G_ARG_INIT			/* initialization of global variables */

/* Handling of pointers to structures */
#define sInc(poi) ++(poi)
#define sDec(poi) --(poi)
#define sIdx(array,index) ((array) + (index))
#define sAdd(poi,displacement) ((poi) += (displacement))
#define sSub(poi,displacement) ((poi) -= (displacement))


/* byte/word/dword type */
typedef unsigned char byte;
typedef unsigned word;
typedef int FLAG;	/* no special 8-bit handling */
typedef unsigned FLAG8;	/* no special 8-bit handling */
#define TO_FP(var) ((void far*) (var))	/* cast variable to far pointer */
#define FARARG(var,type) type far* var
#define COPYFARARG(var) var

typedef unsigned long dword;
#define setDW(var,seg,ofs) ((var) = (dword)MK_FP(seg,ofs))
#define setDWP(varP,seg,ofs) (*(varP) = (dword)MK_FP(seg,ofs))
#define DW_LO(var) ((word)(var))
#define DW_HI(var) ((word)((var) >> 16))
#define DWP_LO(var) ((word)(var))
#define DWP_HI(var) ((word)((var) >> 16))
#define DWARG dword

/* Simulate long constants and long arguments */
#define TO_LONG(num) (unsigned long)(num)
#define MK_LONG(hi,lo) (((unsigned long)(hi) << 16) | (unsigned)(lo))

#define peekw peek
#define pokew poke

#ifndef NULL
#define NULL ((void*)0)
#endif

#define longcpy(a,b) ((a) = (b))
#define longset(a,b) ((a) = (b))
#define longmul(a,b) ((a) *= (b))
#define longdiv(a,b) ((a) /= (b))
#define longadd(a,b) ((a) += (b))
#define longsub(a,b) ((a) -= (b))
#define longtst(a) (!!(a))

#define _osversion MK_OSVERS(_osmajor, _osminor)

#endif	/* _MICROC_ */

#endif
